//======================================================== IBJmth.h
//
// Mathematical Routines for IBJ-programs
// ======================================
//
// Copyright (C) Dr. Lutz Janicke, Dunum, Germany, 1999-2000
// email: lj@janicke.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// history:
//
// last change: 98-07-31  lj
// 2000-07-27 uj  extended for IBJodor
//
//==================================================================

#ifndef  IBJMTH_INCLUDE
#define  IBJMTH_INCLUDE

#ifndef ABS
#define ABS(a) (((a)>0) ? (a) : -(a))
#endif

extern char *MthVersion;

typedef struct {
  float x, y, z;
  } VECTOR;

typedef struct {
  float xx, xy, xz, yx, yy, yz, zx, zy, zz;
  } MATRIX;

extern float Pi;
extern float Ga[5], Gg[5];

double Erfc(       // Complementary Error Function
double x )
  ;
double Gamma( double x )
  ;
double GammaP( double x, double p )
  ;
double BssI0( double x )
  ;
void PrnV( VECTOR a )
  ;
void PrnM( MATRIX a )
  ;
VECTOR MulSV( float f, VECTOR a )
  ;
MATRIX MulSM( float f, MATRIX a )
  ;
float DotVV( VECTOR a, VECTOR b )
  ;
float AbsV( VECTOR a )
  ;
VECTOR CroVV( VECTOR a, VECTOR b )
  ;
VECTOR DotVM( VECTOR a, MATRIX b )
  ;
VECTOR DotMV( MATRIX a, VECTOR b )
  ;
MATRIX DotMM( MATRIX a, MATRIX b )
  ;
MATRIX TrnM( MATRIX a )
  ;
VECTOR DefV( float x, float y, float z )
  ;
MATRIX DefM(
float xx, float xy, float xz,
float yx, float yy, float yz,
float zx, float zy, float zz )
  ;
VECTOR AddVV( VECTOR a, VECTOR b )
  ;
VECTOR SubVV( VECTOR a, VECTOR b )
  ;
MATRIX AddMM( MATRIX a, MATRIX b )
  ;
MATRIX SubMM( MATRIX a, MATRIX b )
  ;
MATRIX DyaVV( VECTOR a, VECTOR b )
  ;
MATRIX DefR2( float x, float y )
  ;
MATRIX ChlM( MATRIX a )
  ;
float DetM( MATRIX a )
  ;
MATRIX InvM( MATRIX a )
  ;
int GssJrd(     /* Gauss-Jordan elimination */
int n,          /* number of unknowns       */
float *amat,    /* n x n matrix elements    */
int m,          /* number of rhs-vectors    */
float *bmat)    /* n x m matrix elements    */
    ;
#endif  /*#################################################################*/
