//======================================================== IBJprm.h
//
// Header for Input Routine IBJprm.c
// =================================
//
// Copyright (C) Dr. Lutz Janicke, Dunum, Germany, 1999-2000
// email: lj@janicke.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// history:
//
// last change: 98-07-31  lj
//
//==================================================================

#ifndef  IBJPRM_INCLUDE
#define  IBJPRM_INCLUDE

#define PRM_ISCHAR      0x000001
#define PRM_ISINT       0x000002
#define PRM_ISFLOAT     0x000003
#define PRM_ISDOUBLE    0x000004
#define PRM_ISSTRING    0x000005
#define PRM_ISPOINTER   0x000006    //-99-01-21
#define PRM_ISANY       0x00000f
#define PRM_ISARRAY     0x000100
#define PRM_DATSET      0x010000

#define PRM_BUFLEN    200
#define PRMDATSET(n)  (0 != (PrmTab.n.type & PRM_DATSET))

typedef struct {
        char *name;
        char *input_format, *output_format;
        char *default_value;
        char *reference;
        long size, number, type;
        union {
                int i;
                float f;
                double d;
                void *p;
        } u;
        char *description;
}  PRMTABREC;

extern int PrmEcho;
extern int PrmBufSize;
extern char *PrmVersion;
extern char PrmLabel[];

int PrmInit(    // Initialize the data structure DmdTab
  int level )   // 1: scalars and strings only
;               // 2: allocate and initialize vectors

int PrmReset(     // Reset the data structure DmdTab
void )            // free or clear all parameters
;
int PrmSet(     // Returns 1, if the parameter ist set by the user
char *name )    // name of the parameter
;
PRMTABREC *PrmFind( // Find a parameter in PrmTab
char *name,         // name of the parameter
char *cmd )         // name of the section
;
int PrmPrnRec(  // Print a record value into a string
char *b,        // string buffer
int maxlen,     // length of buffer
PRMTABREC *pt ) // address of selected record
;
int PrmPrnList( // Print a list of values into a string
char *b,        // string buffer
int maxlen,     // buffer length
char *cmd,      // name of selected section
... )           // parameter names or new section (NULL ends)
;
int PrmPrint(   // Print all data in PrmTab
char *sec )     // selected section
;
int PrmRead(    // Read command file
  char *fn,     // file name (complete with path and extension)
  char *cmd,    // returned: first command found
  char *arg )   // returned: argument part
;

#endif  // IBJPRM_INCLUDE